<?php
/**
 * Plugin Name: Partnerprogram-software
 * Plugin URI: https://partnerprogramm-software.eu
 * Description: Partnerprogram-software
 * Version: 1.0
 * Author: Partnerprogram-software
 * Author URI: https://partnerprogramm-software.eu
 */

class partnerprogram_software {

    function __construct()
    {

        add_option('mlmpartner_url', '');
        add_action( 'init', array(&$this, 'partnerprogram_software_init'));
        add_action( 'wp', array(&$this, 'partnerprogram_software_redirect'));
        add_action( 'wp_head', array(&$this, 'partnerprogram_software_head'));
        add_action( 'pre_get_posts', array(&$this, 'partnerprogram_software_pre_get_posts'));
        add_filter( 'query_vars', array(&$this, 'partnerprogram_software_query_vars'));
        add_action('admin_menu',  array (&$this, 'partnerprogram_software_admin') );
        add_action('rest_api_init',  array (&$this, 'partnerprogram_software_api_init') );
        add_action( 'wp_ajax_get_partner', array (&$this, 'partnerprogram_software_ajax_get_partner'));
        add_action( 'wp_ajax_nopriv_get_partner', array (&$this, 'partnerprogram_software_ajax_get_partner'));
        add_action( 'woocommerce_new_order', array (&$this, 'partnerprogram_new_order_partnerid') );
        add_action( 'woocommerce_account_dashboard', array (&$this, 'partnerprogram_show_user_partner_field') );
        add_action( 'woocommerce_created_customer', array (&$this, 'partnerprogram_new_customer_partnerid'), 10, 3 );
        add_action('show_user_profile', array (&$this, 'partnerprogram_show_extra_profile_fields'));
        add_action('edit_user_profile', array (&$this, 'partnerprogram_show_extra_profile_fields'));



        add_shortcode( 'pps_partnerid', array (&$this, 'partnerprogram_software_shortcode'));

        add_action( 'template_redirect', function () {
            switch ( get_query_var( 'name' ,'') ) {
                case 'wphook-virtual-page':
                    require_once __DIR__.'/inc/ppsVirtualPage.php';
                    $args = array('slug' => 'wphook-virtual-page',
                        'title' => 'PPS Stat',
                        'content' => $this->getPartnerId()."<script>alert(1);</script>",
                        'type' => 'post');
                    $pg = new ppsVirtualPage($args);
                    break;
            }


        } );
    }

    function partnerprogram_show_extra_profile_fields($user) {
        echo('<h3>Extra profile information</h3>');

        echo '<table class="form-table">
            <tr>
                <th><label for="user_birthday">PartnerID</label></th>
                <td>
                    ' . esc_attr(get_user_meta($user->ID, 'PartnerID', true)) . '
                </td>
            </tr>
        </table>';
    }

    function partnerprogram_new_customer_partnerid($customer_id, $new_customer_data, $password_generated) {
        $pid = $this->getPartnerId();
        update_user_meta( $customer_id, 'PartnerID', $pid );
    }

    function partnerprogram_show_user_partner_field() {
        $pid = get_user_meta( get_current_user_id(), 'PartnerID', true );

        if ( $pid ) {
            echo '<p><strong>' . __( 'PartnerID', 'woocommerce' ) . ':</strong> ' . $pid . '</p>';
        }

    }
    function partnerprogram_new_order_partnerid($order_id) {
        $order = new WC_Order( $order_id );
        if (!$order->get_meta('PartnerID')) {
            $pid = $this->getPartnerId();
            $order->update_meta_data('PartnerID', $pid);
            $order->save();
        }
    }

    function getPartnerId() {

        if ( ! session_id() ) {
            session_start();
        }
        $res = '';
        $vp = get_query_var('vp');
        if ($vp) {
            $_SESSION['mlmpartnerId'] = preg_replace("/[^a-zA-Z0-9]+/", "", $vp);
            if (isset($_SESSION['mlmstarterid'])) {
                unset($_SESSION['mlmstarterid']);
            }
        }
        if (!empty($_GET['partnerid'])) {
            $_SESSION['mlmpartnerId'] = preg_replace("/[^a-zA-Z0-9]+/", "", $_GET['partnerid']);
        }
        if(!empty($_SESSION['mlmpartnerId'])) {
            $res = esc_html($_SESSION['mlmpartnerId']);
        }
        if ($res) {
            define( "DONOTCACHEPAGE", true );
        }
        return $res;
    }

    function getStarterId() {

        if ( ! session_id() ) {
            session_start();
        }
        $res = '';
        $starterid = get_query_var('starterid');
        if ($starterid) {
            $_SESSION['mlmstarterid'] = preg_replace("/[^a-zA-Z0-9]+/", "", $starterid);
            if (isset($_SESSION['mlmpartnerId'])) {
                unset($_SESSION['mlmpartnerId']);
            }
        }
        if (!empty($_GET['starterid'])) {
            $_SESSION['mlmpstarterid'] = preg_replace("/[^a-zA-Z0-9]+/", "", $_GET['starterid']);
        }
        if(!empty($_SESSION['mlmstarterid'])) {
            $res = esc_html($_SESSION['mlmstarterid']);
        }
        if ($res) {
            define( "DONOTCACHEPAGE", true );
        }
        return $res;
    }

    function partnerprogram_software_head($vars)
    {
        $locale = get_locale();
        $locale = explode("_",$locale);
        $locale = $locale[0];
        $site_url = get_option('mlmpartner_url');
        if (!$site_url) {
            $site_url = get_option('siteurl');
        }
        if (substr($site_url, strlen($site_url)-1, 1) == '/') {
            $site_url = substr($site_url, 0, strlen($site_url)-1);
        }
        $script = "
                var partnerScriptURL = '".esc_url($site_url)."/home';
                var partnerLang = '$locale';
                //var restApiUrl = '".get_rest_url(0,'/partnerprogramm-software/getpartnerid')."';
                var restApiUrl = '".admin_url('admin-ajax.php')."';
        ";


        wp_enqueue_script('partnerprogram_software_partner', plugins_url ('/js/partner.js', __FILE__));
        wp_add_inline_script( 'partnerprogram_software_partner', $script, 'before');

        wp_enqueue_style('partnerprogram_software_style', plugins_url ('/css/partner.css', __FILE__));
    }

    function partnerprogram_software_query_vars ($vars)
    {
        $vars[] = 'vp';
        $vars[] = 'pps_stat';
        $vars[] = 'contactgroupid';
        $vars[] = 'starterid';
        return $vars;
    }

    function getShopPage() {
        $url = get_option( 'woocommerce_shop_page_id' );
        if( !$url ) {
            $url = get_option( 'page_on_front' );
        }
        return $url;
    }

    function partnerprogram_software_init ()
    {
        add_rewrite_tag('%pps_stat%', '([^&]+)');
        add_rewrite_tag('%vp%', '([^&]+)');
        add_rewrite_tag('%contactgroupid%', '([^&]+)');
        add_rewrite_tag('%empfehlungsgeber%', '([^&]+)');

        add_rewrite_rule(
            'pps_stat\/([a-z0-9A-Z]+)\/?$',
            'index.php?pps_stat=$matches[1]',
            'top'
        );
        add_rewrite_rule(
            'shop\/vp\/([a-z0-9A-Z]+)\/?$',
            'index.php?page_id='.$this->getShopPage().'&vp=$matches[1]',
            'top'
        );

        add_rewrite_rule(
            'vp\/([a-z0-9A-Z]+)\/?$',
            'index.php?page_id='.get_option( 'page_on_front' ).'&vp=$matches[1]',
            'top'
        );

        add_rewrite_rule(
            'empfehlungsgeber\/([a-z0-9A-Z]+)\/?$',
            'index.php?page_id='.get_option( 'page_on_front' ).'&starterid=$matches[1]',
            'top'
        );

        add_rewrite_rule(
            'contactgroupid\/([a-z0-9A-Z]+)\/?$',
            'index.php?page_id='.get_option( 'page_on_front' ).'&contactgroupid=$matches[1]',
            'top'
        );

        add_rewrite_rule(
            'contactgroupid\/([a-z0-9A-Z]+)\/vp\/([a-z0-9A-Z]+)\/?$',
            'index.php?page_id='.get_option( 'page_on_front' ).'&contactgroupid=$matches[1]&vp=$matches[2]',
            'top'
        );

        add_rewrite_rule(
            'vp\/([a-z0-9A-Z]+)\/contactgroupid\/([a-z0-9A-Z]+)\/?$',
            'index.php?page_id='.get_option( 'page_on_front' ).'&contactgroupid=$matches[2]&vp=$matches[1]',
            'top'
        );


        flush_rewrite_rules();
    }

    function partnerprogram_software_redirect() {
        if (is_404() && !is_admin()) {
            global $wp;
            $request = $wp->request;
            if (strpos($request,'/') === false) {
                $url = get_option('siteurl')."/vp/".$request;
                header ('HTTP/1.1 301 Moved Permanently');
                header ("Location: " . $url);
                exit();
            }
        }
    }

    function partnerprogram_software_pre_get_posts ($query) {
        if (is_admin() || !$query->is_main_query()) {
            return;
        }
        switch ( get_query_var( 'pps_stat' ,'') ) {
            case 'registercomplete':
                require_once __DIR__.'/inc/ppsVirtualPage.php';
                $args = array('slug' => 'pps_stat/registercomplete',
                    'title' => 'PPS Stat',
                    'content' => $this->getPartnerId(),
                    'type' => 'post');
                $pg = new ppsVirtualPage($args);
                break;
        }
        $this->getPartnerId();
        $this->getStarterId();
        if(!empty(get_query_var('vp')) || !empty(get_query_var('contactgroupid'))  || !empty(get_query_var('starterid')) ) {
            remove_filter('template_redirect', 'redirect_canonical');
        }
    }

    function partnerprogram_software_admin ()
    {
        if ( function_exists('add_options_page') )
        {
            add_options_page('MLM-Partner Options',
                'Partnerprogram-software', 8, basename(__FILE__),
                array (&$this, 'partnerprogram_software_admin_form') );
        }
    }

    function partnerprogram_software_api_init(){
        $namespace = 'partnerprogramm-software';

        $rout = '/getpartnerid';

        $rout_params = [
            'methods'  => 'GET',
            'callback' => array(&$this, 'partnerprogram_software_api_callback'),
            'permission_callback' => function( $request ){
                return true;
            },
        ];

        register_rest_route( $namespace, $rout, $rout_params );

    }

    function partnerprogram_software_api_callback( WP_REST_Request $request ){
        $res = $this->getPartnerId();
        $result = new WP_REST_Response(['partnerid'=>$res], 200);
        return $result;
    }


    function partnerprogram_software_ajax_get_partner(){
        $partner = $this->getPartnerId();
        $starter = $this->getStarterId();
        echo json_encode(['partnerid'=>$partner, 'starterid' => $starter]);
        wp_die();
    }

    function partnerprogram_software_shortcode(){
        $res = $this->getPartnerId();
        return $res;
    }

    function partnerprogram_software_admin_form()
    {
        $mlmpartner_url = get_option('mlmpartner_url');

        if ( isset($_POST['submit']) )
        {
            if ( function_exists('current_user_can') &&
                !current_user_can('manage_options') )
                die ( _e('Hacker?', 'mlmpartner') );

            if (function_exists ('check_admin_referer') )
            {
                check_admin_referer('partnerprogram_software_admin_form');
            }

            $mlmpartner_url = sanitize_url($_POST['mlmpartner_url']);

            update_option('mlmpartner_url', $mlmpartner_url);
        }
        ?>
        <div class='wrap'>
            <h2><?php _e('Partnerprogram-software Einstellungen', 'mlmpartner'); ?></h2>

            <form name="mlmpartner" method="post"
                  action="<?php echo $_SERVER['PHP_SELF']; ?>?page=partnerprogram-software.php&amp;updated=true">

                <!-- Name mlmpartner_url is used in check_admin_referer -->
                <?php
                if (function_exists ('wp_nonce_field') )
                {
                    wp_nonce_field('partnerprogram_software_admin_form');
                }
                ?>

                <table class="form-table">
                    <tr>
                        <th scope="row"><?php _e('Partnerprogram URL:', 'mlmpartner'); ?></th>

                        <td>
                            <input type="text" name="mlmpartner_url"
                                   size="80" value="<?php echo esc_url($mlmpartner_url); ?>" />
                        </td>
                    </tr>


                </table>

                <input type="hidden" name="action" value="update" />

                <input type="hidden" name="page_options"
                       value="mlmpartner_url" />

                <p class="submit">
                    <input type="submit" name="submit" value="<?php _e('Speichern') ?>" />
                </p>
            </form>
        </div>
        <?php
    }

}



$mlmpartner = new partnerprogram_software();

?>